#codon substituted junction seq, does all junctions

#general stuff
rm(list=ls()) #ctrl L for clearing the workspace


#PACKAGES TO INSTALL
#source("https://eur04.safelinks.protection.outlook.com/?url=http%3A%2F%2Fbioconductor.org%2FbiocLite.R&amp;data=02%7C01%7C%7C0131c697a3934d5fc72508d6128ab3eb%7C84df9e7fe9f640afb435aaaaaaaaaaaa%7C1%7C0%7C636716784256644491&amp;sdata=T%2FH0pwiZmhR0R9UGyubb7dP2Qo9SG%2BSnR2mrHMG6JxI%3D&amp;reserved=0")
#biocLite("Biostrings") #for working with genetic material in R
#install.packages("devtools") # if you have not installed "devtools" package #For easy saving for loop output
#devtools::install_github("hoxo-m/magicfor")
#install.packages("seqinr") #for the read and write fasta functions

#PACKAGES TO LOAD
require(Biostrings)
library(magicfor)
library(seqinr)


#VARIABLES TO SET
setwd("/home/gemma/Documents/iGEM/RstudioiGEM/sequencegenerator") #set working directory to where you have your sequence saved and would like to save the generated file
Gene <- "EPOcDNAv2_582bps.fasta" #insert file name HERE
Junctions <- c(159,246,426) #positions of the junctions in bps
junctionregion <- 3 #size of region to alter on both sides of the junction in bps. Should be divisible by 3.
outfile <- "EPOcDNAmutatedjunctions_72seq.fasta" #name of output file

#####################################################################
############### RUN FROM HERE ON SHOULD BE AUTOMATIC#################

## Translating DNA to aa
Gene <- read.fasta(Gene, as.string = TRUE)
Gene <- as.character(Gene)
Gene <- strsplit(Gene, NULL)
Gene <-unlist(Gene)
Geneaa <-translate(Gene)

Junctionsaa <- floor(Junctions/3) #all in frame (includes a rounding step if junctions are not in frame?)

#define junction regions, so define of which amino acids should the codons be substituted  
magic_for() # call magic_for() to save loop output
for (i in Junctionsaa){
  x <- c((i-(junctionregion/3)):(i+(junctionregion/3)))
put(x)
}
x2 <-magic_result() #displays saved values from loop in a list, all aa that need to be optimised in numbers.
x2 <-x2$x

#translate junction regions in numbers to amino acids 
magic_for()
for (i in x2){ 
  aa <- Geneaa[i]
  put (aa)
}
aaseq <- magic_result()
aaseq <- aaseq$aa

#generate all possible bps sequences for the junction regions
magic_for()
for (i in aaseq){ 
  temp <- vector ()
  codons1 <- list ()
  for (aa in 1:length(i)){
  temp <- names(GENETIC_CODE[GENETIC_CODE==i[aa]])
  codons1[[length(codons1)+1]] <- temp
  }
sequence <- expand.grid(codons1) #generate all substituted dna in a dataframe
cols <- c(names(sequence))
sequence$new <- apply( sequence[ , cols ] , 1 , paste , collapse = "" )
sequence <- sequence[ , !( names(sequence) %in% cols ) ]
sequence <- strsplit(sequence, NULL)
put(sequence)
}
sequences <- magic_result()
sequences <- unlist(sequences, recursive= FALSE)
names(sequences) <- Junctions


#put all possible sequences into Gene and save and output as fasta. 
  #This code replaces the sequence of only 1 part of the gene, so as to limit the number of output sequences
magic_free()
Generep1 <-list()
for (i in names(sequences)){
    y <- (as.numeric(i)-junctionregion):(as.numeric(i)+junctionregion+2) #156:164 
    for (k in sequences[[i]]){ #l bps 1:9. k list of 48, 8, 16 resp
      Generep <-print(replace(Gene, y, k))
      Generep1[[length(Generep1)+1]] <- Generep
    }
}
write.fasta(sequences = Generep1, names = names(Generep1), file.out = outfile)