##############################Sequence mutator#########################################

#general stuff
rm(list=ls()) #ctrl L for clearing the workspace

#PACKAGES TO INSTALL
#install.packages("seqinr") #for the read and write fasta functions
library(seqinr)

#VARIABLES TO SET
setwd("/home/gemma/Documents/iGEM/RstudioiGEM/sequencegenerator") #set working directory to where you have your sequence saved and would like to save the generated file
Gene <- "sequenceEPOfull.fasta" #insert file name HERE
truereadrate <- .80 #accuracy of the sequencer, default .92 for ONT single read sequencing
seqamount <- 10 #amount of sequences to be generated with the mutations
outfile <- "EPOnatural8percent10seq.fasta" #name of output file

#####################################################################
############### RUN FROM HERE ON SHOULD BE AUTOMATIC#################

#read fasta sequence and store as vector with individual elements
Gene <- read.fasta(Gene, as.string = TRUE)
Gene <- as.character(Gene)
Gene <- strsplit(Gene, NULL)
Gene <-unlist(Gene)

#prepare a container from which to pick replacement values for positions that should be mutated
bases <- c("A", "T", "G", "C") #bases used to replace
values <- sample(bases, length(Gene), replace=TRUE) #all the replacement values, a random sequence of bases with same length as the gene

#correct for replacing a basepair with its original basepair (25% chance)
truereadrate <- 1-((1-truereadrate)*1.25)

#select basepairs to be altered and replace them with random basepairs and save output in a fasta file
r1 <-runif(10000,0,1)
mrGene <-vector()
mrGene2 <- vector()
for (j in 1:seqamount){
  for (i in 1:length(Gene)){
    r2 <-sample(r1,1,replace=TRUE)
    if (r2>=truereadrate){
      x <-values[i]  #select a value from values (with for example index=index i in Gene)
    }
    else {
      x <- Gene[i] #add value from Gene at index i to empty vector
    }
    mrGene [i] <- x
  }
  mrGene2 [j] <-list(mrGene, j)
}
write.fasta(sequences = mrGene2, names = names(mrGene2), file.out = outfile)